/*
 * JMGPU driver
 *
 * Copyright (c) 2020 ChangSha JingJiaMicro Electronics Co., Ltd.
 * All rights reserved. 
 *
 * Author:
 *      wj <jjwgpu@jingjiamicro.com>
 * 
 * The software and information contained herein is proprietary and 
 * confidential to JingJiaMicro Electronics. This software can only be 
 * used by JingJiaMicro Electronics Corporation. Any use, reproduction, 
 * or disclosure without the written permission of JingJiaMicro 
 * Electronics Corporation is strictly prohibited.
 *
 */
 




#ifndef __2d75b2da_H_
#define __2d75b2da_H_

#include "jmgpu_integrity.h"
#include "jmgpu_license.h"
#include "jmgpu_calendar.h"




struct tag_jmk_VGKERNEL
{

    j9_scalpra                   object;


    jmk_OS                       os;


    jmk_VGHARDWARE                   hardware;


    jmk_VGINTERRUPT              interrupt;


    jmk_VJMOMMAND                    command;


    jmtPOINTER                  context;


    jmk_VGMMU                        mmu;

    jmk_KERNEL                   kernel;
};

#if 0

typedef union tag_jmu_VIDMEM_NODE
{

    struct tag_jms_VIDMEM_NODE_VIDMEM
    {

        jmk_VIDMEM               memory;


        jmuVIDMEM_NODE_PTR      next;
        jmuVIDMEM_NODE_PTR      prev;


        jmuVIDMEM_NODE_PTR      nextFree;
        jmuVIDMEM_NODE_PTR      prevFree;


        jmtUINT32               address;
        jmtSIZE_T               bytes;
        jmtUINT32               alignment;


        jmtINT32                locked;
    }
    VidMem;


    struct _AQVIDMEM_NODE_VIRTUAL
    {

        jmk_KERNEL               kernel;


        jmtPHYS_ADDR            physical;
        jmtSIZE_T               bytes;
        jmtPOINTER              logical;


        jmtSIZE_T               pageCount;
        jmtPOINTER              pageTable;
        jmtUINT32               address;


        jmtPOINTER              mutex;


        jmtINT32                locked;
    }
    Virtual;
}
jmu_VIDMEM_NODE;


struct tag_jmk_VIDMEM
{

    j9_scalpra                   object;


    jmk_OS                       os;


    jmtSIZE_T                   baseAddress;
    jmtSIZE_T                   bytes;
    jmtSIZE_T                   freeBytes;


    jmtINT                      mapping[J9_HANDLE__KLENDUSIVE];


    jmu_VIDMEM_NODE              sentinel[J9_HANDLE__KLENDUSIVE];


    jmtSIZE_T                   threshold;


    jmtPOINTER                  mutex;
};
#endif

struct tag_jmk_VGMMU
{

    j9_scalpra                   object;


    jmk_OS                       os;


    jmk_VGHARDWARE                   hardware;


    jmtPOINTER                  mutex;


    jmtSIZE_T                   pageTableSize;
    jmtPHYS_ADDR                pageTablePhysical;
    jmtPOINTER                  pageTableLogical;


    jmtUINT32                   entryCount;
    jmtUINT32                   entry;
};

#endif


